"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var postcss_1 = __importDefault(require("postcss"));
var options_1 = require("./utilities/options");
var atrules_1 = require("./parsers/atrules");
var rules_1 = require("./parsers/rules");
var rules_2 = require("./utilities/rules");
var _types_1 = require("./@types");
exports.Mode = _types_1.Mode;
exports.Source = _types_1.Source;
var transformer = function (options) {
    if (options === void 0) { options = {}; }
    return (function (css) {
        var optionsParsed = options_1.normalizeOptions(options);
        var keyframes = [];
        var rules = [];
        if (optionsParsed.processKeyFrames) {
            atrules_1.parseKeyFrames(keyframes, css, optionsParsed);
        }
        var keyFramesStringMap = atrules_1.getKeyFramesStringMap(keyframes);
        var keyFrameData = {
            length: keyframes.length,
            keyframes: keyframes,
            stringMap: keyFramesStringMap,
            regExp: atrules_1.getKeyFramesRegExp(keyFramesStringMap)
        };
        atrules_1.parseAtRules(rules, keyFrameData, css, optionsParsed);
        rules_1.parseRules(rules, keyFrameData, css, optionsParsed);
        rules_2.appendRules(rules);
        rules_2.appendKeyFrames(keyframes);
    });
};
exports.postcssRTLCSS = postcss_1.default.plugin('postcss-rtlcss', transformer);
